<?
class pazzl {

const _FREE = -1;
const _ERR = -100; // лениво было, поэтому использую свой код ошибки


private $frames=array(),
         $a_game=array(),
         $part=3, // на сколько рядов разбиваем рисунок по умолчанию
         $img='';         

var  $msg='',
     $file='',  // данные игры
     $pics=''; // Данные картинок

 function __construct($file,$pic='img/default.jpg',$size=4)
  {
  
  $this->file = $file;
  $this->pics = md5($file); // хранилище фрагметов

  $this->img = $pic;  // картинка для пазла
  $this->part = $size;// размер пазла


  if (file_exists($this->file) && file_exists($this->pics)) // надо чтобы оба файла были
   {
   $a_game_data=array();   
   $a_game_data=unserialize(file_get_contents($this->file));  
   $this->a_game=$a_game_data[0];
   //$this->part=$a_game_data[1];
   }
  else $this->create_pazzl() ; 
  }
//----------//
 function save_game()
  {
  $a_game_data=array();
  $a_game_data[0]=$this->a_game;
  $a_game_data[1]=$this->part;  
  file_put_contents($this->file,serialize($a_game_data));
  } 
//----------//
 function create_pazzl ()
  {  
  if (!file_exists($this->img)) die ('File not found!');
  
  $this->msg = 'Создаем новый пазл';
  $this->a_game=array();
  $this->frames=array();  
  
  $tipe = GetImageSize ($this->img);
  
  $x=$xx=intval($tipe[0]/$this->part);
  $y=$yy=intval($tipe[1]/$this->part);  
  
  $img_fone=imagecreatetruecolor($x,$y); //fone
  $col=imagecolorallocate($img_fone, 255, 255, 255);  
  
  if ($tipe[2]==1) $img_work = ImageCreateFromGIF($this->img);
  elseif ($tipe[2]==2) $img_work = ImageCreateFromJPEG($this->img);
  elseif ($tipe[2]==3) $img_work = ImageCreateFromPNG($this->img);
  else die ('Это не рисунок');  
  
  ob_start(); //создаем буфер для хранения изображений

  for ($a=0;$a<intval($tipe[1]/$y);$a++)
   for ($i=0;$i<intval($tipe[0]/$x);$i++) 
   {
   imagefilledrectangle ($img_fone, 0, 0,$x, $y, $col); // стираем фон
   imagecopyresampled($img_fone,$img_work,0,0,$xx*$i,$yy*$a,  $xx,$yy,$x,$y);      
   
   //--Грабли--//  
   imagejpeg($img_fone, NULL ,75);  
   $this->frames[]=ob_get_contents();  
   ob_clean(); // очищаем буфер
   //---------//  
   }
 
  ob_end_clean();
  imagedestroy($img_fone);
  imagedestroy($img_work);  
  
  // сохраняем наши фреймы
  file_put_contents($this->pics,serialize($this->frames));    
  
  for ($i=0;$i<count($this->frames)-1;$i++) // заполняем игровой массив
   {
   $this->a_game[]=$i;   
   }  
  $this->a_game[]=pazzl::_FREE; // последний елемет empty  
  $this->my_shuffle(count($this->a_game)-1); // если применить shuffle($this->a_game); не вариант что головоломка соберется
  $this->save_game();
  return;
  }
//----------//
 function get_frame($fr)
  { 
  if (file_exists($this->pics))
   { 
   $this->frames=unserialize(file_get_contents($this->pics));    
   return $this->frames[$fr]; 
   } else die ('Frames not found!');   
  }
//----------//
function print_board()
 {
 $res='<table style="background:#00FF00;" border="0">'; 
 
 for ($y=0;$y<$this->part;$y++)
  {
  $res.= '<tr>';
  for ($x=0;$x<$this->part;$x++)
   {
   $i=$y*$this->part+$x;   
   if ($this->a_game[$i] == pazzl::_FREE) $res.= '<td></td>';
    else
     $res.= '<td><a href="?m='.$i.'"><img src="part_'.$this->a_game[$i].'.gif" alt="'.$i.'"></a></td>';   
   }  
  $res.= '</tr>';
  } 
 $res.='</table>';
 return $res;
 }
//----------//
function is_legal_move($m)
 {
 $a_coord=array(-1,1,$this->part,$this->part*-1); //направления для поиска хода 
  for ($i=0;$i<4;$i++)
   {
   $mv=$m+$a_coord[$i];   
   if (!array_key_exists($mv,$this->a_game)) {continue;} // вылезли за пределы массива;   
   if ($this->a_game[$m+$a_coord[$i]] == pazzl::_FREE)  // нашли ход
    {      
    switch ($a_coord[$i]) {   //переходы на новую строку
    case 1:   
    if (($m+1)%$this->part==0 ) return pazzl::_ERR;    
    break;   
    case -1:   
    if ($m%$this->part==0) return pazzl::_ERR;  
    break;    
    }     
    return $mv; // Это правильный ход!    
    } 
   } 
 return pazzl::_ERR; 
 }  
//----------//
function my_move($m)
 {
 $a_coord=array(-1,1,$this->part,$this->part*-1); //направления для поиска хода
 $mv=$this->is_legal_move($m); 
  if ($mv != pazzl::_ERR) 
   {    
   $this->a_game[$mv] =$this->a_game[$m];   
   $this->a_game[$m] = pazzl::_FREE; 
   
   if ($this->is_win()) //echo 'Победа!!!';
    {
    $this->msg = 'Поздравляю, вы правильно собрали картинку';    
    // показываем отсутствующий элемент
    $this->a_game[count($this->a_game)-1] = $this->a_game[count($this->a_game)-2]+1;    
    }     
   $this->save_game();
   return true;  
  } 
 $this->msg = 'Не правильный ход!'; 
 return false;
 }
//----------//
function is_win()
 { 
 for ($i=0;$i < count($this->a_game)-1;$i++)
  {
  if ($this->a_game[$i] != $i) return FALSE;
  }
 return true;
 }
//----------//
function my_shuffle ($em) // чтобы головоломка собралась перемешиваем пазл двигая пустую клетку
 {
 $a_coord=array(-1,1,$this->part,$this->part*-1); //направления для поиска хода  
 for ($j=0;$j < $this->part*$this->part*10;$j++)
  {
  $mv=mt_rand(0,3); //случайное направление  
  for ($i=0;$i<4;$i++)
   {
   $go=$em+$a_coord[$mv];  
   if (!array_key_exists($go,$this->a_game)) // ход не возможен ищем следующий
    {
    $mv++;
    if ($mv > 3) $mv=0;
    } 
   else
    {    
    $this->a_game[$em] =$this->a_game[$go];   
    $this->a_game[$go] = pazzl::_FREE; 
    $em=$go;
    break;  
    }  
   } 
  } 
 }
//----------//
}

?>